<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">

import { ref, inject} from 'vue';
import { useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';
import { useMetaStore } from '@/stores/meta';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { useBaseStore } from '@/stores/base';
import { storeToRefs } from 'pinia';
import { adminMenuEnum, notificationStatus } from '@/enums/enums';

const { t } = useI18n();
const $t = t; 

const router = useRouter();
const store = useMetaStore();
const { openMenu } = storeToRefs(store);

const props = defineProps<{
    modelValue?: Boolean
}>();
const baseStore = useBaseStore();
const { status, message } = storeToRefs(baseStore);
let configuration = inject<any>('configuration');

const emits = defineEmits<{
    //(e: "update:modelValue", value:boolean):void
    (e: "close", value:boolean):void
}>();

const submitModal = async ()=>{
    try{
        let result = await request('POST', configuration.apiServer + '/api/delete/'+ store.hashcode, undefined, 'application/json', false, true);
        if(result.status!=="ok"){
            if(result.error === "password wrong"){
                status.value = notificationStatus.DANGER;
                message.value = $t('login.errorShort'); 
            } 
            else{
                status.value = notificationStatus.DANGER;
                message.value = $t('general.errors.unexpected');
            }
            //emits('close', false);
            openMenu.value = adminMenuEnum.NONE;
        }else{
            //emits('close', false);
            openMenu.value = adminMenuEnum.NONE;
            router.push({name: "home"});
        }
    }catch(error){
        console.error(error);
        status.value = notificationStatus.DANGER;
        message.value = $t('general.errors.unexpected');
        //emits('close', false);
        openMenu.value = adminMenuEnum.NONE;
    }

}

const closeModal = ()=>{
    //emits('close', false);
    openMenu.value = adminMenuEnum.NONE;
}

</script>
<template>
<div>
    <Modal :header="$t('adminMenu.pageDelete.label')" 
        :text="$t('adminMenu.pageDelete.title')"
        :labelCancel="$t('general.buttons.cancel')" 
        :labelSubmit="$t('general.buttons.send')" @submit="submitModal" @cancel="closeModal">
    </Modal>
</div>
</template>